
L.SVG = L.Renderer.extend({

	onAdd: function (map) {
		var container = this._container = L.SVG.create('svg');

		if (this._zoomAnimated) {
			L.DomUtil.addClass(container, 'leaflet-zoom-animated');
		}

		this.getPane().appendChild(container);
		this._update();
	},

	onRemove: function () {
		L.DomUtil.remove(this._container);
	},

	_update: function () {
		if (this._map._animatingZoom) { return; }

		L.Renderer.prototype._update.call(this);

		var b = this._bounds,
		    size = b.getSize(),
		    container = this._container,
		    pane = this.getPane();

		// hack to make flicker on drag end on mobile webkit less irritating
		if (L.Browser.mobileWebkit) {
			pane.removeChild(container);
		}

		L.DomUtil.setPosition(container, b.min);
		container.setAttribute('width', size.x);
		container.setAttribute('height', size.y);
		container.setAttribute('viewBox', [b.min.x, b.min.y, size.x, size.y].join(' '));

		if (L.Browser.mobileWebkit) {
			pane.appendChild(container);
		}
	}
});

L.SVG.create = function (name) {
	return document.createElementNS('http://www.w3.org/2000/svg', name);
};

L.SVG.updatePoly = function (path, points, closed) {
	for (var i = 0, len = points.length; i < len; i++) {

	}
};

L.Browser.svg = !!(document.createElementNS && L.SVG.create('svg').createSVGRect);
